#ifndef NSITEJUMPONCONE_H
#define NSITEJUMPONCONE_H

#include "base.h"

#include <random>
#include <vector>

namespace motions {
    class NSiteJumpOnCone final : public BaseMotion {
    public:
        NSiteJumpOnCone(double, double, int, double, std::mt19937_64&);
        explicit NSiteJumpOnCone(std::mt19937_64&);

        void initialize() override;
        double jump() override;

        [[nodiscard]] std::string toString() const override;

        void setParameters(const std::unordered_map<std::string, double> &) override;
        [[nodiscard]] std::unordered_map<std::string, double> getParameters() const override;

    private:
        int m_num_sites{2};
        std::vector<double> m_sites{};
        double m_chi{1./2.};
        int m_cone_idx = 0;
        coordinates::SphericalPos m_axis{1, 0};
        std::uniform_int_distribution<> m_chooser;
    };
} // motions

#endif //NSITEJUMPONCONE_H
