
#ifndef SIXSITEJUMP_H
#define SIXSITEJUMP_H

#include "base.h"

#include <random>
#include <cmath>
#include <array>

namespace motions {
    class SixSiteOctahedronC3 final : public BaseMotion {
    public:
        SixSiteOctahedronC3(double, double, double, std::mt19937_64&);
        explicit SixSiteOctahedronC3(std::mt19937_64&);

        void initialize() override;
        double jump() override;

        [[nodiscard]] std::string toString() const override;

    private:
        const double m_chi{0.95531661812450927816385710251575775424341469501000549095969812932191204590};  // 54.74 deg

        std::array<double, 6> m_corners{};
        int m_corner_idx{0};

        std::uniform_int_distribution<> m_chooser{1, 5};

    };
}
#endif //SIXSITEJUMP_H
